/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"

void StackEventHandler(uint32 event, void *eventParam)
{
    switch(event)
    {
        case CY_BLE_EVT_STACK_ON :
            //Cy_BLE_GAPP_StartAdvertisement(CY_BLE_ADVERTISING_FAST, CY_BLE_BROADCASTER_CONFIGURATION_0_INDEX);
            break;

        case CY_BLE_EVT_GAPP_ADVERTISEMENT_START_STOP:
//            if(Cy_BLE_GetAdvertisementState() != CY_BLE_ADV_STATE_ADVERTISING)
//            {
//                /* Advertisement event timed out, go to low power
//                 * mode (Stop mode) and wait for device reset
//                 * event to wake up the device again */
//                
//                Cy_BLE_GAPP_StartAdvertisement(CY_BLE_ADVERTISING_FAST, CY_BLE_BROADCASTER_CONFIGURATION_0_INDEX);
//               
//            }
            break;

        default:
            break;
    }
}

/* Initialize alarm time which is three seconds after system start */
cy_stc_rtc_alarm_t myRtcAlarmConfig = 
{
    .sec            = 3u,
    .secEn          = CY_RTC_ALARM_ENABLE,
    .min            = RTC_INITIAL_DATE_MIN,
    .minEn          = CY_RTC_ALARM_DISABLE,
    .hour           = RTC_INITIAL_DATE_HOUR,
    .hourEn         = CY_RTC_ALARM_DISABLE,
    .dayOfWeek      = RTC_INITIAL_DATE_DOW,
    .dayOfWeekEn    = CY_RTC_ALARM_DISABLE,
    .date           = RTC_INITIAL_DATE_DOM,
    .dateEn         = CY_RTC_ALARM_DISABLE,
    .month          = RTC_INITIAL_DATE_MONTH,
    .monthEn        = CY_RTC_ALARM_DISABLE,
    .almEn          = CY_RTC_ALARM_ENABLE
};

void Cy_RTC_Alarm1Interrupt(void)
{
    //Cy_RTC_ClearInterrupt(BACKUP_INTR_ALARM1_Msk);
}

void Cy_RTC_Alarm2Interrupt(void)
{
    //Cy_RTC_ClearInterrupt(BACKUP_INTR_ALARM2_Msk);
}

void Cy_RTC_CenturyInterrupt(void)
{
    //Cy_RTC_ClearInterrupt(BACKUP_INTR_CENTURY_Msk);
}

void RtcInterruptHandler(void)
{
    /* No DST parameters are required for the custom tick. */
    Cy_RTC_Interrupt(NULL, false);
}

cy_en_rtc_status_t RtcInit(void)
{
    uint32_t initTimeout = 500u;
    cy_en_rtc_status_t initRtc;
    
    /* RTC block doesn't allow to access, when synchronizing the user registers
       and the internal actual RTC registers.It will return RTC_BUSY value, if it 
       is not available to update the configuration values. Needs to retry, if it
       doesn't return CY_RTC_SUCCESS */
    do
    {
        initRtc = Cy_RTC_Init(&RTC_config);
        initTimeout--;
        
        Cy_SysLib_Delay(5u);
    } while(( initRtc != CY_RTC_SUCCESS) && (initTimeout != 0u));
    
	return (initRtc);
}

cy_en_rtc_status_t RtcConfigAlarm(cy_stc_rtc_alarm_t *myRtcAlarmConfig)
{
    uint32_t timeout = 500u;
    cy_en_rtc_status_t retStatus;
    
    /* RTC block doesn't allow to access, when synchronizing the user registers
       and the internal actual RTC registers.It will return RTC_BUSY value, if it 
       is not available to update the configuration values. Needs to retry, if it
       doesn't return CY_RTC_SUCCESS */
    do
	{
		retStatus = Cy_RTC_SetAlarmDateAndTime(myRtcAlarmConfig, CY_RTC_ALARM_1);
		timeout--;
        
		Cy_SysLib_Delay(5u);
    } while(( retStatus != CY_RTC_SUCCESS) && (timeout != 0u));
    
	if(retStatus == CY_RTC_SUCCESS)
    {
        /* Set interrupt for next custom alarm */
		Cy_RTC_SetInterruptMask(CY_RTC_INTR_ALARM1);
    }
    
	return (retStatus);
}



int main(void)
{


    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    Cy_BLE_Start(StackEventHandler);
    
    
    /* Initialize RTC */
    if(CY_RTC_SUCCESS != RtcInit())
    {
        /* If operation fails, halt */
        CY_ASSERT(0u);
    }
    else
    {
        /* Configure RTC alarm */
        if(CY_RTC_SUCCESS != RtcConfigAlarm(&myRtcAlarmConfig))
        {
            /* If operation fails, halt */
            CY_ASSERT(0u);
        }
    }
    
    /* Enable RTC interrupt handler function */
    Cy_SysInt_Init(&RTC_RTC_IRQ_cfg, RtcInterruptHandler);
    NVIC_EnableIRQ(RTC_RTC_IRQ_cfg.intrSrc);

    
    __enable_irq(); /* Enable global interrupts. */
    Cy_BLE_ProcessEvents();
    
    for(;;)
    {
        Cy_BLE_GAPP_StopAdvertisement ();
        Cy_GPIO_Inv(P1_1_PORT, P1_1_NUM);

        Cy_RTC_SetDateAndTimeDirect(0u, 0u, 00u, 1u, 1u, 18u);
        
        while(Cy_BLE_GetAdvertisementState() != CY_BLE_ADV_STATE_STOPPED)
        {
            Cy_BLE_ProcessEvents();
        }

        Cy_BLE_GAPP_StartAdvertisement(CY_BLE_ADVERTISING_FAST, CY_BLE_BROADCASTER_CONFIGURATION_0_INDEX);
        while(Cy_BLE_GetAdvertisementState() != CY_BLE_ADV_STATE_ADVERTISING)
        {
            Cy_BLE_ProcessEvents();
        }
        
//        for(uint8_t n = 0; n<10; n++)
//        {
//            
//        }
        
        Cy_SysLib_Delay(7);
        
        /* Go to Deep Sleep mode until next interrupt  */
        Cy_SysPm_DeepSleep(CY_SYSPM_WAIT_FOR_INTERRUPT);
    }
}

/* [] END OF FILE */
